#!/usr/bin/python3

import os, sys, struct, shutil
from sys import argv
from stat import *

#typedef struct {
#        char name[32];
#        u32 filesize;
#        u32 flags;
#        u32 spritefollow;
#        u32 reserved;
#} romheader;

#emptysave = "\xff" * 65536

def readfile(name):
	try:
		fd = open(name, "rb")
		contents = fd.read()
		fd.close()
	except IOError:
		print("Error reading", name)
		sys.exit(1)
	return contents

def writefile(name, contents):
	try:
		fd = open(name, "wb")
		fd.write(contents)
		fd.close()
	except IOError:
		print("Error writing", name)
		sys.exit(1)

if __name__ == "__main__":
	if len(argv) < 4:
		print("Usage: %s pocketnes.gba rom romtitle [splashscreen]")
		sys.exit(0)
	pocketnes = readfile(argv[1])
	rom = readfile(argv[2])
	rom = rom + b"\0" * (len(rom)%4)
	romheader = struct.pack("31scIIII", argv[3].encode('ascii'), b"\0", len(rom), 0, 0, 0)
	outputfilename = os.path.splitext(argv[2])[0] + ".gba"
	outputpatchname = os.path.splitext(argv[2])[0] + ".pat"
	#outputsavename = os.path.splitext(argv[2])[0] + ".sav"
	if len(argv) == 5:
		#splash screen is simply concatenated after emulator binary, no header needed
		writefile(outputfilename, pocketnes + readfile(argv[4]) + romheader + rom)
	else:
		writefile(outputfilename, pocketnes + romheader + rom)
	# EZ-Flash IV GSS patcher metadata to force 64KB SRAM saves (no pre-creation of .sav files is necessary for fw2.xx)
	shutil.copy2("../emupatch.pat", outputpatchname)
